\chapter{Analysis of memcached}

\section{Goals}
Name the goals that you work towards.
Example:

\inlineheadingbf{Goal 1}
Analyze \texttt{memcached/proto_proxy.c} method\\
\lstinline{void process_proxy_stats(void *arg, ADD_STAT add_stats, conn *c)}
with regards to property \texttt{valid-memcleanup}.
This method has 84~lines of code.
It contains memory operations with \lstinline{memset},
multiple for loops (also nested for-loops), and a number of macros
that must be resolved (e.g., \lstinline{STAT_L}).
There is use of concurrency: \lstinline{pthread_mutex_lock}.
We ignore concurrency and only analyze the method in isolation.


\section{Experiment Environment}

Describe what machine you used to run your experiments.
This should include the concrete hardware, operating system, and software versions
(e.g., which Linux Kernel version?).

Describe how you installed the tools and source code below.

\begin{setup*}
    \begin{goal}
        Set up tool BmcChecker and an own repository fork of memcached,
        to be able to run BmcChecker and track own modifications on memcached files.
    \end{goal}
    
    \begin{steps}
        \item Change into an empty project directory.
        \item Create a fork of memcached\footnote{\url{https://github.com/memcached/memcached}}
            and change it to a private repository.
        \item Clone the forked memcached:

            \begin{lstlisting}
> git clone git@github.com:username/memcached.git
            \end{lstlisting}

            Output:

            \begin{lstlisting}
Cloning into 'memcached'...
remote: Enumerating objects: 9631, done.
remote: Counting objects: 100% (658/658), done.
remote: Compressing objects: 100% (265/265), done.
remote: Total 9631 (delta 460), reused 457 (delta 391), pack-reused 8973
Receiving objects: 100% (9631/9631), 4.76 MiB | 1.69 MiB/s, done.
Resolving deltas: 100% (6916/6916), done.
            \end{lstlisting}

        \item Download \texttt{bmcchecker.zip} from SV-COMP archives 2023: \url{https://gitlab.com/sosy-lab/sv-comp/archives-2023/}
        \item Unzip \texttt{bmcchecker.zip} into the project directory.
            This produces directory \texttt{bmcchecker/}
    \end{steps}

    \begin{results}
        An own memcached fork is available at directory \texttt{memcached/},
        and BmcChecker is available at directory \texttt{bmcchecker/}.
    \end{results}
\end{setup*}


\section{Analysis Report}
Describe your analysis steps in detail.
Each step \textbf{has to follow} the below template; some examples are given.

\begin{experiment}[First run]
    \label{experiment:first}
    \begin{goal}
        Perform a first explorative run of the tool on \texttt{memcached/proto_proxy.c}
        method \lstinline{void process_proxy_stats(...)},
        to see what the tool produces on a naive run.
    \end{goal}
    \begin{steps}
        \item Change into directory memcached.
        \item Run the tool on \texttt{memcached/proto_proxy.c} with the default \svcomp~2023 configuration
            for property \texttt{valid-memcleanup}:

        \begin{lstlisting}
> ../../tools/bmcchecker/bin/bmcchecker.sh \
    --property ../sv-benchmarks/c/properties/valid-memcleanup.prp \
    --entrymethod process_proxy_stats \
    proto_proxy.c
        \end{lstlisting}

        Output:

        \begin{lstlisting}
Some hypothetical tool output...
CRASH: Out of memory
        \end{lstlisting}

    \end{steps}

    \begin{results}
        BmcChecker crashes with an out-of-memory error.
    \end{results}
\end{experiment}

\begin{experiment}[Run with reduced method]
    \label{experiment:reduced}
    \begin{goal}
        Try to avoid the previously encountered out-of-memory error of BmcChecker (see \cref{experiment:first}),
        by removing the nested loop in the code of method\\ \lstinline{void process_proxy_stats(..)}.
    \end{goal}

    \begin{steps}
        \item Remove the following code from file \texttt{memcached/proto\_proxy.c}:
            \begin{lstlisting}[language=diff]
diff --git a/proto_proxy.c b/proto_proxy.c
index 890ed2d..f7d973a 100644
--- a/proto_proxy.c
+++ b/proto_proxy.c
@@ -66,27 +66,6 @@ void process_proxy_stats(void *arg, ADD_STAT add_stats, conn *c) {
     uint64_t counters[us->num_stats];
     memset(counters, 0, sizeof(counters));
 
-    // TODO (v3): more globals to remove and/or change API method.
-    // aggregate worker thread counters.
-    for (int x = 0; x < settings.num_threads; x++) {
-        LIBEVENT_THREAD *t = get_worker_thread(x);
-        struct proxy_user_stats *tus = t->proxy_user_stats;
-        struct proxy_int_stats *is = t->proxy_int_stats;
-        WSTAT_L(t);
-        for (int i = 0; i < CMD_FINAL; i++) {
-            istats.counters[i] += is->counters[i];
-        }
-        if (tus && tus->num_stats >= us->num_stats) {
-            for (int i = 0; i < us->num_stats; i++) {
-                counters[i] += tus->counters[i];
-            }
-        }
-        WSTAT_UL(t);
-        pthread_mutex_lock(&t->proxy_limit_lock);
-        buffer_memory_used += t->proxy_buffer_memory_used;
-        pthread_mutex_unlock(&t->proxy_limit_lock);
-    }
-
     // return all of the user generated stats
     for (int x = 0; x < us->num_stats; x++) {
         if (us->names[x]) {
            \end{lstlisting}

        \item Run the tool on \texttt{memcached/proto_proxy.c} with the default \svcomp~2023 configuration
            for property \texttt{valid-memcleanup}:

        \begin{lstlisting}
> ../../tools/bmcchecker/bin/bmcchecker.sh \
    --property ../sv-benchmarks/c/properties/valid-memcleanup.prp \
    --entrymethod process_proxy_stats \
    proto_proxy.c
        \end{lstlisting}

        Output:

        \begin{lstlisting}
Some hypothetical tool output...
Verdict: FALSE (violation of valid-memcleanup)
        \end{lstlisting}

        \item Get the failing test inputs from \texttt{output/Counterexample.html}:
                $\langle 5, 10\rangle$.
    \end{steps}

    \begin{results}
    BmcChecker finishes the analysis successfully and finds
    a property violation of property \texttt{valid-memcleanup}
    when inputs $\langle 5, 10\rangle$ are used.
    \end{results}
\end{experiment}

\begin{experiment}[Validate Result of \cref{experiment:reduced}]
    \label{experiment:debugging}
    \begin{goal}
        Find out whether the property violation found in \cref{experiment:reduced}
        is a false positive or a real bug.
    \end{goal}

    \ldots
\end{experiment}


\newpage
\section{Discussion}
Tell the reader what you learned from the analysis. What worked well, what did not work?
What future work would be necessary to improve on what you did?
How could the experience be improved?